﻿package
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.filters.BlurFilter;
	import flash.geom.Matrix;
	import flash.geom.Point;
	public class Sinuser extends Sprite
	{
		private var bmp:BitmapData;
		private var angle:uint = 0;
		private var support:Sprite = new Sprite();
		private var filterObj:BlurFilter = new BlurFilter(0,0,0);
		private var colors:Array = [0xff000,0xff0000];
		public function Sinuser()
		{
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
		}
		private function addedHandler(e:Event):void
		{
			bmp = new BitmapData(stage.stageWidth,stage.stageHeight,false,0x000000);
			addChild(new Bitmap(bmp));
			addEventListener(Event.ENTER_FRAME,enterHandler);
		}
		private function buildCycle(target:Sprite,angle:uint):Sprite
		{	
			var point:Sprite = new Sprite();
			point.graphics.beginFill(colors[angle%10],20);
			point.graphics.drawCircle(10,10,4);
			point.graphics.endFill();
			target.addChild(point);
			point.x = Math.cos(angle*Math.PI/1080)*100;
			point.y = Math.sin(angle*Math.PI/1080)*100;
			return point;
		}
		private function enterHandler(e:Event):void
		{
			var basis:Sprite = new Sprite();
			basis.x = stage.stageWidth/3;
			basis.y = stage.stageHeight/3;
			support.addChild(basis);
			for(var i:uint=0;i<3;i++){
				basis = buildCycle(basis,angle*i);
			}
			var m:Matrix = new Matrix();
			m.rotate(angle/80);
			m.translate(stage.stageWidth*1,stage.stageHeight*1);
			m.scale(0.4,0.4);
			if(angle%60 == 0){
				bmp.applyFilter(bmp,bmp.rect,new Point(0,0),filterObj);
			}
			bmp.draw(support,m);
			support.removeChildAt(0);
			angle++;
		}
	}
}